#!/bin/sh
#
# This code is distributed under the terms of the GPL
#
# IPCop UPS Server AddOn Script
#
# $Id: upsmsg.sh ver. 0.5.8 from 12/04/2008 s.feddersen Exp $
#
# Copyright (c) 2005-2008 by Stephan Feddersen
#

hostname=`hostname`
time=`grep -a TIMELEFT /var/log/ups/status`
date=`date "+%a, %e.%m.%Y %H:%M:%S"`
myipfile=/var/ipcop/apcupsd/myipfile
mailsettings=/var/ipcop/apcupsd/mailsettings

lang=`grep -e LANGUAGE= /var/ipcop/main/settings | cut -d= -f2`
msg1=`grep -e 'ups_menu' /var/ipcop/apcupsd/msg.$lang.pl | cut -d"'" -f4`

if  [ 'de' = $lang ]; then
msg1="$msg1 vom $hostname"
elif [ 'en' = $lang ]; then
msg1="$msg1 on $hostname"
else
msg1="$msg1 on $hostname"
fi

event=ups_msg_${1}

msg2=`grep -e $event /var/ipcop/apcupsd/msg.$lang.pl | cut -d"'" -f4`

if [ -z "$msg2" ];
	then
		msg2=`grep -e $event /var/ipcop/apcupsd/msg.en.pl | cut -d"'" -f4`
	fi

if [ '' != "$msg2" ]; then

	if [ -e "$myipfile" ]; then
	
		if [ -e "/var/ipcop/msgclient/send2client"  ]; then
	
			for host in `cut -f2 -d, $myipfile`
			do
				/var/ipcop/msgclient/send2client -c $host -t "$msg1|$msg2|$time"
				/usr/bin/logger -t apcupsd "Message send over send2client ...."
			done

		elif [ -e "/usr/local/samba/bin/smbclient" ]; then

			temp=/var/log/ups/smb_msg
			echo $msg1 > $temp
			echo $msg2 >> $temp
			echo $time >> $temp

			for host in `cut -f3 -d, $myipfile`
			do
				cat $temp | /usr/local/samba/bin/smbclient -M $host
				/usr/bin/logger -t apcupsd "Message send over smbclient ...."
				/bin/rm -fr $temp
			done

		else
			true
		fi
	else
		true
	fi

	if [ -e "$mailsettings" ]; then

		if [ -e "/var/ipcop/apcupsd/sendEmail" ]; then

			temp=/var/log/ups/mail_msg

			echo $msg1 > $temp
			echo $msg2 >> $temp
			echo $time >> $temp

			mail=`grep -w MAIL $mailsettings | cut -f2 -d=`
			from_address=`grep -w MAILFROM $mailsettings | cut -f2 -d=`
			to_address1=`grep -w MAILTO1 $mailsettings | cut -f2 -d=`
			to_address2=`grep -w MAILTO2 $mailsettings | cut -f2 -d=`
			smtpserver=`grep -w MAILSERVER $mailsettings | cut -f2 -d=`
			smtpport=`grep -w MAILSMTP $mailsettings | cut -f2 -d=`
			username=`grep -w MAILNAME $mailsettings | cut -f2 -d=`
			password=`grep -w MAILPW $mailsettings | cut -f2 -d=`

			if [ "$mail" = "on" ]; then

				if [ '' = $username ] && [ '' = $password ]; then
					/var/ipcop/apcupsd/sendEmail -q -l /var/log/ups/sendemail.log -f $from_address -t $to_address1 -t $to_address2 -u "$msg1 - $date - $msg2"  -o message-file=/var/log/ups/mail_msg -s $smtpserver:$smtpport
					/usr/bin/logger -t apcupsd "Message send over sendEmail client ...."
					/bin/rm -fr $temp
				elif [ '' = $password ]; then
					/var/ipcop/apcupsd/sendEmail -q -l /var/log/ups/sendemail.log -f $from_address -t $to_address1 -t $to_address2 -u "$msg1 - $date - $msg2"  -o message-file=/var/log/ups/mail_msg -s $smtpserver:$smtpport -xu $username
					/usr/bin/logger -t apcupsd "Message send over sendEmail client ...."
					/bin/rm -fr $temp
				else
					/var/ipcop/apcupsd/sendEmail -q -l /var/log/ups/sendemail.log -f $from_address -t $to_address1 -t $to_address2 -u "$msg1 - $date - $msg2"  -o message-file=/var/log/ups/mail_msg -s $smtpserver:$smtpport -xu $username -xp $password
					/usr/bin/logger -t apcupsd "Message send over sendEmail client ...."
					/bin/rm -fr $temp
				fi
			else
				true
			fi
		else
			true
		fi
	else
		true
	fi
else
	true
fi