#!/usr/bin/perl
#
# IPCop UPS Server AddOn CGI
#
# This code is distributed under the terms of the GPL
#
# $Id: ups.cgi ver. 0.5.8 from 12/04/2008
#
# Copyright (c) 2005-2008 by Stephan Feddersen
#

# enable the following only on debugging purpose
#
#use warnings;
#use CGI::Carp 'fatalsToBrowser';

use strict;
use LWP::UserAgent;

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my %upssettings = ();
my %netsettings = ();
my %mainsettings = ();
my %upsmailsettings = ();
my %cgiparams = ();

my %checked = ();
my %selected = ();

my $errormessage = '';

my $addonversion = '0.5.8';
my $addonname = 'UPS Server';
my $addonupdate = "${General::swroot}/apcupsd/.update";
my $addoncheck = &updatecheck($addonversion);

my $apcupsdver = `/sbin/apcupsd -V`;

my $smbclient = '/usr/local/samba/bin/smbclient';
my $msgclient = "${General::swroot}/msgclient/send2client";
my $mailclient = "${General::swroot}/apcupsd/sendEmail";
my $logfile = "/var/log/ups/sendemail.log";
my $eventfile = "/var/log/ups/events";
my $ipfile = "${General::swroot}/apcupsd/myipfile";
my $pidalive = 0;

my @dummygreen = ( ${Header::colourgreen} );
my @dummyred = ( ${Header::colourred} );
my @dummyyellow = ( ${Header::colouryellow} );
my @dummytable1 = ( ${Header::table1colour} );
my @dummytable2 = ( ${Header::table2colour} );

undef (@dummygreen);
undef (@dummyred);
undef (@dummyyellow);
undef (@dummytable1);
undef (@dummytable2);

my %servicenames = ( $Lang::tr{'ups_menu1'} => 'apcupsd', );

&Header::showhttpheaders();

&General::readhash("${General::swroot}/ethernet/settings", \%netsettings);
&General::readhash("${General::swroot}/main/settings", \%mainsettings);

my $language = $mainsettings{'LANGUAGE'};

$upssettings{'ACTION'} = '';
$upssettings{'DUMMY'} = '';
$upssettings{'FQDN'} = "$mainsettings{'HOSTNAME'}.$mainsettings{'DOMAINNAME'}";
$upssettings{'ENABLE'} = 'off';
$upssettings{'HTTPS'} = 'off';
$upssettings{'HTTP'} = 'off';
$upssettings{'IPCOP'} = 'off';
$upssettings{'NISONGREEN'} = '';
$upssettings{'UPSNAME'} = $mainsettings{'HOSTNAME'};
$upssettings{'UPSCABLE'} = 'smart';
$upssettings{'UPSTYPE'} = 'apcsmart';
$upssettings{'UPSMODEL'} = 'smartups';
$upssettings{'DEVICE'} = '/dev/ttyS0';
$upssettings{'UPSDEVICE'} = 'COM1';
$upssettings{'LOCKFILE'} = '/var/lock';
$upssettings{'ONBATTERYDELAY'} = '5';
$upssettings{'BATTERYLEVEL'} = '15';
$upssettings{'MINUTES'} = '5';
$upssettings{'TIMEOUT'} = '0';
$upssettings{'ANNOY'} = '300';
$upssettings{'ANNOYDELAY'} = '60';
$upssettings{'NOLOGON'} = 'always';
$upssettings{'KILLDELAY'} = '0';
$upssettings{'NETSERVER'} = 'on';
$upssettings{'NETTIME'} = '15';
$upssettings{'MASTER'} = '';
$upssettings{'NISIP'} = $netsettings{'GREEN_ADDRESS'};
$upssettings{'NISPORT'} = '3551';
$upssettings{'EVENTSFILE'} = '/var/log/ups/events';
$upssettings{'EVENTSFILEMAX'} = '10';
$upssettings{'UPSCLASS'} = 'standalone';
$upssettings{'UPSMODE'} = 'disable';
$upssettings{'LOGSTATS'} = 'off';
$upssettings{'DATATIME'} = '0';
$upssettings{'STATTIME'} = '10';
$upssettings{'STATFILE'} = '/var/log/ups/status';
$upssettings{'MULTIMON'} = '/cgi-bin/multimon.cgi';
$upssettings{'UPSSTATS'} = '/cgi-bin/upsstats.cgi';
$upssettings{'HTTPPORT'} = '';
$upssettings{'HTTPSPORT'} = '';
$upssettings{'KILLPOWER'} = '';
$upssettings{'UPSSNMPIP'} = '';
$upssettings{'UPSSNMPPORT'} = '161';
$upssettings{'UPSSNMPTYPE'} = 'APC';
$upssettings{'UPSSNMPCOMMUNITY'} = 'public';

$upsmailsettings{'MAIL'} = 'off';
$upsmailsettings{'ACTION'} = '';
$upsmailsettings{'MAILSERVER'} = '';
$upsmailsettings{'MAILSMTP'} = '25';
$upsmailsettings{'MAILFROM'} = '';
$upsmailsettings{'MAILNAME'} = '';
$upsmailsettings{'MAILPW'} = '';
$upsmailsettings{'MAILTO1'} = '';
$upsmailsettings{'MAILTO2'} = '';

$cgiparams{'ACTION'} = '';
$cgiparams{'HOSTNAME'} = '';
$cgiparams{'DOMAINNAME'} = $mainsettings{'DOMAINNAME'};
$cgiparams{'IPADDR'} = '';

&Header::getcgihash(\%upssettings);
&Header::getcgihash(\%netsettings);
&Header::getcgihash(\%mainsettings);
&Header::getcgihash(\%upsmailsettings);
&Header::getcgihash(\%cgiparams);

############################################################################################################################

if ($cgiparams{'ACTION'} eq $Lang::tr{'add'}) {

	open(FILE, $ipfile) or die 'Unable to open myipfile.';
	my @current = <FILE>;
	close(FILE);

	my $key = 0;

	unless(&General::validip($cgiparams{'IPADDR'}))
	{
		$errormessage = $Lang::tr{'invalid fixed ip address'};
	}

	unless(&General::validhostname($cgiparams{'HOSTNAME'}))
	{
		$errormessage = $Lang::tr{'invalid hostname'};
	}

	if ($cgiparams{'DOMAINNAME'})
	{
		unless(&General::validdomainname($cgiparams{'DOMAINNAME'}))
		{
			$errormessage = $Lang::tr{'invalid domain name'};
		}
	}

	if ( ! $errormessage)
	{
		if ($cgiparams{'IPADDR'} && $cgiparams{'HOSTNAME'}) {
			if ($cgiparams{'EDITING'} eq 'no')
			{
				foreach my $line (@current) { $key++; }
				open(FILE,">>$ipfile") or die 'Unable to open myipfile.';
				print FILE "$key,$cgiparams{'IPADDR'},$cgiparams{'HOSTNAME'},$cgiparams{'DOMAINNAME'}\n";
			} else {
				open(FILE,">$ipfile") or die 'Unable to open myipfile.';
				foreach my $line (@current)
				{
					chomp($line);
					my @temp = split(/\,/,$line);
					if ($cgiparams{'EDITING'} eq $temp[0]) {
						print FILE "$temp[0],$cgiparams{'IPADDR'},$cgiparams{'HOSTNAME'},$cgiparams{'DOMAINNAME'}\n";
					} else { print FILE "$line"; }
				}
			}
			close(FILE);
			undef %cgiparams;
		}
	} else {
		if ($cgiparams{'EDITING'} ne 'no')
		{
			$cgiparams{'ACTION'} = $Lang::tr{'edit'};
			$cgiparams{'KEY1'} = $cgiparams{'EDITING'};
		}
	}
}

############################################################################################################################

if ($cgiparams{'ACTION'} eq $Lang::tr{'edit'}) {

	open(FILE, $ipfile) or die 'Unable to open myipfile.';
	my @current = <FILE>;
	close(FILE);

	foreach my $line (@current)
	{
		chomp($line);
		my @temp = split(/\,/,$line);

		if ($cgiparams{'KEY1'} eq $temp[0]) {
			$cgiparams{'IPADDR'} = $temp[1];
			$cgiparams{'HOSTNAME'} = $temp[2];
			$cgiparams{'DOMAINNAME'} = $temp[3];
		}
	}
}

############################################################################################################################

if ($cgiparams{'ACTION'} eq $Lang::tr{'remove'}) {

	my @current = ();

	open(FILE, ">$ipfile") or die 'Unable to open myipfile.';
	flock FILE, 2;
	my $key = 0;

	foreach my $line (@current)
	{
		chomp($line);
		my @temp = split(/\,/,$line);

		unless ($cgiparams{'KEY1'} eq $temp[0]) {
			print FILE "$key,$temp[1],$temp[2],$temp[3]";
			$key++;
		}
	}
	close(FILE);
}

############################################################################################################################

if ($upsmailsettings{'ACTION'} eq $Lang::tr{'upsmailsave'}) {

if ($upsmailsettings{'MAILTO1'} ne '') {
	unless(&General::validemail($upsmailsettings{'MAILTO1'})) { $errormessage = $Lang::tr{'upsmail_error'}; }
	}
if ($upsmailsettings{'MAILTO2'} ne '') {
	unless(&General::validemail($upsmailsettings{'MAILTO2'})) { $errormessage = $Lang::tr{'upsmail_error'}; }
	}
if ($upsmailsettings{'MAILFROM'} ne '') {
	unless(&General::validemail($upsmailsettings{'MAILFROM'})) { $errormessage = $Lang::tr{'upsmail_error'}; }
	}

if ( ! $errormessage) {

&General::writehash("${General::swroot}/apcupsd/mailsettings", \%upsmailsettings);

open (FILE, ">${General::swroot}/apcupsd/mailsettings") or die "Unable to write apcupsd mailsettings.";
flock(FILE, 2);
{
print FILE <<END
MAIL=$upsmailsettings{'MAIL'}
MAILTO1=$upsmailsettings{'MAILTO1'}
MAILTO2=$upsmailsettings{'MAILTO2'}
MAILPW=$upsmailsettings{'MAILPW'}
MAILFROM=$upsmailsettings{'MAILFROM'}
MAILNAME=$upsmailsettings{'MAILNAME'}
MAILSMTP=$upsmailsettings{'MAILSMTP'}
MAILSERVER=$upsmailsettings{'MAILSERVER'}
END
;
}
close FILE;

}

}

############################################################################################################################

if ($upsmailsettings{'ACTION'} eq $Lang::tr{'upsmailtest'}) {

	&General::readhash("${General::swroot}/apcupsd/mailsettings", \%upsmailsettings);

	my $smtpserver = $upsmailsettings{'MAILSERVER'};
	my $smtpport = $upsmailsettings{'MAILSMTP'};
	my $from_address = $upsmailsettings{'MAILFROM'};
	my $username = $upsmailsettings{'MAILNAME'};
	my $password = $upsmailsettings{'MAILPW'};
	my $to_address1 = $upsmailsettings{'MAILTO1'};
	my $to_address2 = $upsmailsettings{'MAILTO2'};
	my $sub = $Lang::tr{'upsmail_sub'};
	my $msg = $Lang::tr{'upsmail_msg'};

	if ($username eq '' && $password eq '') {
		system("$mailclient -q -l $logfile -f $from_address -t $to_address1 -t $to_address2 -u $sub -m $msg -s $smtpserver:$smtpport")
		}
	elsif ($password eq '') {
		system("$mailclient -q -l $logfile -f $from_address -t $to_address1 -t $to_address2 -u $sub -m $msg -s $smtpserver:$smtpport -xu $username")
		}
	else { system("$mailclient -q -l $logfile -f $from_address -t $to_address1 -t $to_address2 -u $sub -m $msg -s $smtpserver:$smtpport -xu $username -xp $password") }

}

############################################################################################################################

my @cgihelp=();

$ENV{'QUERY_STRING'} =~ s/&//g;

@cgihelp = split(/action=/,$ENV{'QUERY_STRING'});
$cgihelp[1] = '' unless defined $cgihelp[1];

if ( $upssettings{'ACTION'} eq $Lang::tr{'ups_help'} || $cgihelp[1] ne '' ) {

my %upssettings =();

&General::readhash("${General::swroot}/apcupsd/settings", \%upssettings);

&Header::getcgihash(\%upssettings);

&Header::openpage($Lang::tr{'ups_help_manual'}, 1, '');

&Header::openbigbox('100%', 'left');

&Header::openbox('100%', 'left', $Lang::tr{'ups_help_manual'});

print <<END
<table width='100%' border='0' cellpadding='1'>
END
;

sub empty_line {
print <<END
	<tr>
		<td valign='top' align='left'>&nbsp;</td>
		<td valign='top' align='left'>&nbsp;</td>
		<td valign='top' align='left'>&nbsp;</td>
	</tr>
END
;
}

sub short_line {
print <<END
	<tr>
		<td valign='top' align='left'>&nbsp;</td>
		<td><hr noshade align='center' width='100%' size='1'></hr></td>
		<td><hr noshade align='center' width='100%' size='1'></hr></td>
	</tr>
END
;
}

sub long_line {
print <<END
	<tr>
		<td valign='top' align='left'><hr noshade align='center' width='100%' size='1'></hr></td>
		<td><hr noshade align='center' width='100%' size='1'></hr></td>
		<td><hr noshade align='center' width='100%' size='1'></hr></td>
	</tr>
END
;
}

sub main_entry {
   print "<tr>\n";
   print "<td width='7%' valign='top' align='left'><a name='$_[0]'><b> $Lang::tr{$_[0]}:</b></a></td>\n";
   print "<td width='8%' valign='top'>&nbsp;</td>\n";
   print "<td width='25%' valign='top'>&nbsp;</td>\n";
   print "</tr>\n";
}

sub entry {
   print "<tr>\n";
   print "<td valign='top' align='left'>&nbsp;\n";
   print "<td valign='top' align='left'><a name='$_[0]'><b> $Lang::tr{$_[0]} </b></a></td>\n";
   print "<td valign='top'>$Lang::tr{$_[1]}</td>\n";
   print "</tr>\n";
}

sub entry_spz {
print "<tr>\n";
print "<td valign='top' align='left'>&nbsp;</td>\n";
print "<td valign='top' align='left'><a name='$_[0]'><b> $Lang::tr{$_[1]} <font color='339933'> eth0 </font> $Lang::tr{$_[2]} </b></a></td>\n";
print "<td valign='top'>$Lang::tr{$_[3]}</td>\n";
print "</tr>\n";
}

&main_entry ('ups_mainsettings');
&empty_line;

if ($upssettings{'UPSCLASS'} eq 'standalone')
{
   &entry ('ups_name', 'ups_name_manual');
   &empty_line;
   &short_line;
   &entry ('ups_fqdn', 'ups_fqdn_manual');
   &empty_line;
   &short_line;
   &entry ('ups_modus', 'ups_modus_manual');
   &empty_line;
   &short_line;
   &entry ('ups_type', 'ups_type_manual');
}
if ($upssettings{'UPSCLASS'} eq 'nisslave')
{
   &entry ('ups_name', 'ups_name_manual');
   &empty_line;
   &short_line;
   &entry ('ups_modus', 'ups_modus_manual');
}

&empty_line;
&short_line;
&entry ('ups_refresh', 'ups_refresh_manual');
&empty_line;
&long_line;
&empty_line;

&main_entry ('ups_connections');
&empty_line;
&entry ('ups_cable', 'ups_cable_manual');
&empty_line;
&short_line;

if ($upssettings{'UPSCLASS'} eq 'standalone')
{
   &entry ('ups_device', 'ups_device_manual');
}

if ($upssettings{'UPSCLASS'} eq 'nisslave')
{
   &entry ('ups_nismaster', 'ups_nismaster_manual');
   &empty_line;
   &short_line;
   &entry ('ups_nismasterport', 'ups_nismasterport_manual');
   &empty_line;
   &short_line;
   &entry ('ups_nisnettime', 'ups_nisnettime_manual');
}

&empty_line;
&long_line;
&empty_line;
&main_entry ('ups_downsettings');
&empty_line;

if ($upssettings{'UPSCLASS'} eq 'standalone')
{
   &entry ('ups_onbatterydelay', 'ups_onbatterydelay_manual');
   &empty_line;
   &short_line;

	if ($upssettings{'UPSTYPE'} eq 'dumb')
	{
		&entry ('ups_timeout', 'ups_timeout_manual');
		&empty_line;
		&short_line;
	}

	if ($upssettings{'UPSTYPE'} eq 'apcsmart' || $upssettings{'UPSTYPE'} eq 'usb')
	{
		&entry ('ups_timeout', 'ups_timeout_manual');
		&empty_line;
		&short_line;
	}
	
   &entry ('ups_batterylevel', 'ups_batterylevel_manual');
   &empty_line;
   &short_line;
   &entry ('ups_minutes', 'ups_minutes_manual');
}

if ($upssettings{'UPSCLASS'} eq 'nisslave')
{
   &entry ('ups_onbatterydelay', 'ups_onbatterydelay_manual');
   &empty_line;
   &short_line;
   &entry ('ups_timeout', 'ups_timeout_manual1');
   &empty_line;
   &short_line;
   &entry ('ups_batterylevel', 'ups_batterylevel_manual');
   &empty_line;
   &short_line;
   &entry ('ups_minutes', 'ups_minutes_manual');
}

&empty_line;
&long_line;
&empty_line;

if ($upssettings{'UPSCLASS'} eq 'standalone')
{
   &main_entry ('ups_usersettings');
   &empty_line;
   &entry ('ups_annoydelay', 'ups_annoydelay_manual');
   &empty_line;
   &short_line;
   &entry ('ups_annoy', 'ups_annoy_manual');
   &empty_line;
   &short_line;
   &entry_spz ('ups_nisongreen', 'ups_nisongreen1', 'ups_nisongreen2','ups_nisongreen_manual');
   &empty_line;
   &short_line;
   &entry ('ups_nisport', 'ups_nisport_manual');
   &empty_line;
}

if ($upssettings{'UPSCLASS'} eq 'nisslave')
{
   &main_entry ('ups_monitoring');
   &empty_line;
   &entry ('ups_ipcopnis', 'ups_ipcopnis_manual');
   &empty_line;
   &short_line;
   &entry ('ups_http', 'ups_http_manual');
   &empty_line;
   &short_line;
   &entry ('ups_httpport', 'ups_httpport_manual');
   &empty_line;
   &short_line;
   &entry ('ups_https', 'ups_https_manual');
   &empty_line;
   &short_line;
   &entry ('ups_httpsport', 'ups_httpsport_manual');
   &empty_line;
   &short_line;
   &entry ('ups_multimon', 'ups_multimon_manual');
   &empty_line;
   &short_line;
   &entry ('ups_upsstats', 'ups_upsstats_manual');
   &empty_line;
}

print <<END
</table>
END
;

&Header::closebox();

print <<END
<form method='post' action='$ENV{'SCRIPT_NAME'}'>
<table width='50%' align='center'>
<tr>
	<td align='center'><input type='SUBMIT' name='DUMMY' VALUE='$Lang::tr{'ups_back'}'></td>
</tr>
</table>
</form>
END
;

&Header::closebigbox();

&Header::closepage();

exit 0;
}

############################################################################################################################

my @cgigraphs=();

my $graphdir = "/home/httpd/html/graphs";
my $graphs = "/graphs";

$ENV{'QUERY_STRING'} =~ s/&//g;
@cgigraphs = split(/graph=/,$ENV{'QUERY_STRING'});
$cgigraphs[1] = '' unless defined $cgigraphs[1];

if ( $cgigraphs[1] ne '' ) {

&Header::openpage("$Lang::tr{'ups_graphs_openpage'}", 1, '');

&Header::openbigbox('100%', 'left');

if ($cgigraphs[1] =~ /(ups_tempvolt|ups_voltage|ups_timeleft|ups_outputvoltage|ups_loadpct|ups_charge)/) {
	my $graph = $cgigraphs[1];
	my $graphname = ucfirst(lc($cgigraphs[1]));
	&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_graph'});

	if (-e "$graphdir/${graph}_day.png") {
		print "<center>";
		print "<img src='$graphs/${graph}_day.png' border='0' /><hr />";
		print "<img src='$graphs/${graph}_week.png' border='0' /><hr />";
		print "<img src='$graphs/${graph}_month.png' border='0' /><hr />";
		print "<img src='$graphs/${graph}_year.png' border='0' />";
	} else {
		print $Lang::tr{'no information available'};
	}
	&Header::closebox();
	print "<div align='center'><table width='100%'><tr><td align='center'>";
	if ($cgigraphs[1] =~ /(ups_tempvolt|ups_voltage|ups_timeleft|ups_outputvoltage|ups_loadpct|ups_charge)/) {
		print "<a href='/cgi-bin/ups.cgi'>";
	}
	print "<form method='post' action='$ENV{'SCRIPT_NAME'}'><input type='HIDDEN' name='ACTION' value='$Lang::tr{'ups_graphs'}'><INPUT TYPE='submit' NAME='DUMMY' VALUE='$Lang::tr{'ups_back'}'></form></td></tr></table></div>\n";
}

&Header::closebigbox();

&Header::closepage();

exit 0;
}

############################################################################################################################

if ( $upssettings{'ACTION'} eq $Lang::tr{'ups_graphs'} ) {

my @cgigraphs=();

&General::readhash("${General::swroot}/apcupsd/settings", \%upssettings);

my $graphdir = "/home/httpd/html/graphs";
my $graphs = "/graphs";

$ENV{'QUERY_STRING'} =~ s/&//g;
@cgigraphs = split(/graph=/,$ENV{'QUERY_STRING'});
$cgigraphs[1] = '' unless defined $cgigraphs[1];

&Header::openpage("$Lang::tr{'ups_graphs_openpage'}", 1, '');

&Header::openbigbox('100%', 'left');

isrunning ('apcupsd');

if ($pidalive)
{
if ( $upssettings{'UPSTYPE'} eq 'snmp' ) {
&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_temp'});
}
elsif ($upssettings{'UPSTYPE'} eq 'apcsmart' || $upssettings{'UPSTYPE'} eq 'usb') {
&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_tempbatt'});
}
else {
&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_batt'});
}
	if (-e "$graphdir/ups_tempvolt_day.png") {
		my $ftime = localtime((stat("$graphdir/ups_tempvolt_day.png"))[9]);
		print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
		print "<a href='/cgi-bin/ups.cgi?graph=ups_tempvolt'>";
		print "<img src='$graphs/ups_tempvolt_day.png' border='0' />";
		print "</a>";
	} else {
		print $Lang::tr{'no information available'};
	}

&Header::closebox();

&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_voltage'});
	if (-e "$graphdir/ups_voltage_day.png") {
		my $ftime = localtime((stat("$graphdir/ups_voltage_day.png"))[9]);
		print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
		print "<a href='/cgi-bin/ups.cgi?graph=ups_voltage'>";
		print "<img src='$graphs/ups_voltage_day.png' border='0' />";
		print "</a>";
	} else {
		print $Lang::tr{'no information available'};
	}
&Header::closebox();

&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_timeleft'});
	if (-e "$graphdir/ups_timeleft_day.png") {
		my $ftime = localtime((stat("$graphdir/ups_timeleft_day.png"))[9]);
		print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
		print "<a href='/cgi-bin/ups.cgi?graph=ups_timeleft'>";
		print "<img src='$graphs/ups_timeleft_day.png' border='0' />";
		print "</a>";
	} else {
		print $Lang::tr{'no information available'};
	}
&Header::closebox();

&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_outputvoltage'});
	if (-e "$graphdir/ups_outputvoltage_day.png") {
		my $ftime = localtime((stat("$graphdir/ups_outputvoltage_day.png"))[9]);
		print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
		print "<a href='/cgi-bin/ups.cgi?graph=ups_outputvoltage'>";
		print "<img src='$graphs/ups_outputvoltage_day.png' border='0' />";
		print "</a>";
	} else {
		print $Lang::tr{'no information available'};
	}
&Header::closebox();

&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_loadpct'});
	if (-e "$graphdir/ups_loadpct_day.png") {
		my $ftime = localtime((stat("$graphdir/ups_loadpct_day.png"))[9]);
		print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
		print "<a href='/cgi-bin/ups.cgi?graph=ups_loadpct'>";
		print "<img src='$graphs/ups_loadpct_day.png' border='0' />";
		print "</a>";
	} else {
		print $Lang::tr{'no information available'};
	}
&Header::closebox();

&Header::openbox('100%', 'center', $Lang::tr{'ups_graphs_charge'});
	if (-e "$graphdir/ups_charge_day.png") {
		my $ftime = localtime((stat("$graphdir/ups_charge_day.png"))[9]);
		print "<center><b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br />\n";
		print "<a href='/cgi-bin/ups.cgi?graph=ups_charge'>";
		print "<img src='$graphs/ups_charge_day.png' border='0' />";
		print "</a>";
	} else {
		print $Lang::tr{'no information available'};
	}
&Header::closebox();

}
else

{
&Header::openbox('100%', 'left', $Lang::tr{'ups_message'});
print <<END
	<div align="center">
		<table width='100%' cellpadding='1'>
			<td width='100%' align='left'><b>$Lang::tr{'ups_notrunning'}</b></td>
		</table>
	</div>
END
;
&Header::closebox();
}

print <<END
<form method='post' action='$ENV{'SCRIPT_NAME'}'>
<table width='50%' align='center'>
<tr>
	<td align='center'><input type='SUBMIT' name='DUMMY' VALUE='$Lang::tr{'ups_back'}'></td>
</tr>
</table>
</form>
END
;

&Header::closebigbox();

&Header::closepage();

exit 0;
}

############################################################################################################################

if ( $upssettings{'ACTION'} eq $Lang::tr{'ups_back'} )
{
	&General::readhash("${General::swroot}/apcupsd/settings", \%upssettings);
}

############################################################################################################################

if ($upssettings{'ACTION'} eq $Lang::tr{'ups_log'}) {

&General::readhash("${General::swroot}/apcupsd/settings", \%upssettings);

&Header::getcgihash(\%upssettings);

&Header::openpage($Lang::tr{'ups_log_events'}, 1, '');

&Header::openbigbox('100%', 'left');

&Header::openbox('100%', 'left', $Lang::tr{'ups_log_events'});

my $upsevents = `/usr/bin/tail -n 20 $eventfile`;
my $upstext = &Header::cleanhtml($upsevents,'y');

print "<pre>";
print "$upstext";
print "</pre>";

&Header::closebox();

if ( -e "/var/ipcop/apcupsd/sendEmail" ) {

my $mailevents = `/usr/bin/tail -n 20 $logfile`;
my $mailtext = &Header::cleanhtml($mailevents,'y');

&Header::openbox('100%', 'left', $Lang::tr{'upsmail_log'});

print "<pre>";
print "$mailtext";
print "</pre>";

&Header::closebox();

}

print <<END
<form method='post' action='$ENV{'SCRIPT_NAME'}'>
<table width='50%' align='center'>
<tr>
	<td align='center'><input type='SUBMIT' name='DUMMY' VALUE='$Lang::tr{'ups_back'}'></td>
</tr>
</table>
</form>
END
;

&Header::closebigbox();

&Header::closepage();

exit 0;

}

############################################################################################################################

if ($upssettings{'ACTION'} eq $Lang::tr{'ups_save'}) {

	if ($upssettings{'UPSDEVICE'} eq 'USB') {$upssettings{'DEVICE'} = '/dev/usb/hiddev[0-7]';}
	elsif ($upssettings{'UPSDEVICE'} eq 'COM4')  {$upssettings{'DEVICE'} = '/dev/ttyS3';}
	elsif ($upssettings{'UPSDEVICE'} eq 'COM3')  {$upssettings{'DEVICE'} = '/dev/ttyS2';}
	elsif ($upssettings{'UPSDEVICE'} eq 'COM2')  {$upssettings{'DEVICE'} = '/dev/ttyS1';}
	elsif ($upssettings{'UPSDEVICE'} eq 'COM1')  {$upssettings{'DEVICE'} = '/dev/ttyS0';}
	else  {$upssettings{'DEVICE'} = $upssettings{'UPSDEVICE'};}

	if ($upssettings{'UPSMODEL'} eq 'smartups')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsoffice')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupses')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupscs')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupscsusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsesusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsprousb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupscses')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupspro')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupspropnp')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'newbackupspro')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsofficeusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backups') {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'smartupsusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'smartupsvs')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'powerstack')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'matrixups')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'smartbackupspro')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'shareadv')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'sharebasic')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'netups')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsrs')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsxs')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'snmp')  {$upssettings{'UPSTYPE'} = 'snmp';}
	else {$upssettings{'UPSTYPE'} = 'apcsmart';}

&General::writehash("${General::swroot}/apcupsd/settings", \%upssettings);

open(FILE, ">${General::swroot}/apcupsd/hosts.conf") or die "Unable to write hosts.conf";
flock(FILE, 2);
print FILE <<END

MONITOR $netsettings{'GREEN_ADDRESS'}:$upssettings{'NISPORT'} "$upssettings{'UPSNAME'}"
END
;
close FILE;

open (FILE, ">${General::swroot}/apcupsd/apcupsd.conf") or die "Unable to write apcupsd.conf";
flock(FILE, 2);
if ($upssettings{'UPSCLASS'} eq 'standalone')
{
print FILE <<END
## apcupsd.conf v1.1 ##
# 
## this file was created by ups.cgi ver. $addonversion
#
## settings for standalone modus
#
## General Configuration Directives
#
UPSNAME $upssettings{'UPSNAME'}
UPSCABLE $upssettings{'UPSCABLE'}
UPSTYPE $upssettings{'UPSTYPE'}
END
;
if ($upssettings{'UPSTYPE'} eq 'snmp')
{
print FILE <<END
DEVICE $upssettings{'UPSSNMPIP'}:$upssettings{'UPSSNMPPORT'}:$upssettings{'UPSSNMPTYPE'}:$upssettings{'UPSSNMPCOMMUNITY'}
END
;
}
else
{
print FILE <<END
DEVICE $upssettings{'DEVICE'}
END
;
}
print FILE <<END
LOCKFILE $upssettings{'LOCKFILE'}
#
## Configuration Directives used during Power Failure
#
ONBATTERYDELAY $upssettings{'ONBATTERYDELAY'}
BATTERYLEVEL $upssettings{'BATTERYLEVEL'}
MINUTES $upssettings{'MINUTES'}
TIMEOUT $upssettings{'TIMEOUT'}
ANNOY $upssettings{'ANNOY'}
ANNOYDELAY $upssettings{'ANNOYDELAY'}
NOLOGON $upssettings{'NOLOGON'}
KILLDELAY $upssettings{'KILLDELAY'}
#
## Configuration Directives used by the Network Information Server
#
NETSERVER $upssettings{'NETSERVER'}
END
;
if ($upssettings{'NISONGREEN'} eq 'off')
{
print FILE <<END
NISIP 0.0.0.0
END
;
}
else
{
print FILE <<END
NISIP $upssettings{'NISIP'}
END
;
}
print FILE <<END
NISPORT $upssettings{'NISPORT'}
EVENTSFILE $upssettings{'EVENTSFILE'}
EVENTSFILEMAX $upssettings{'EVENTSFILEMAX'}
#
## Configuration Directives used for sharing informations via network
#
UPSCLASS standalone
UPSMODE disable
#
## Configuration Directives used to Control System Logging
#
STATTIME $upssettings{'STATTIME'}
STATFILE $upssettings{'STATFILE'}
LOGSTATS $upssettings{'LOGSTATS'}
DATATIME $upssettings{'DATATIME'}
END
;
}

if ($upssettings{'UPSCLASS'} eq 'nisslave')
{
print FILE <<END
## apcupsd.conf v1.1 ##
# 
## this file was created by ups.cgi ver. $addonversion
#
## settings for nisslave modus
#
## General Configuration Directives
#
UPSNAME $upssettings{'UPSNAME'}
UPSCABLE $upssettings{'UPSCABLE'}
UPSTYPE net
DEVICE $upssettings{'MASTER'}:$upssettings{'NISPORT'}
LOCKFILE $upssettings{'LOCKFILE'}
#
## Configuration Directives used during Power Failure
#
ONBATTERYDELAY $upssettings{'ONBATTERYDELAY'}
BATTERYLEVEL $upssettings{'BATTERYLEVEL'}
MINUTES $upssettings{'MINUTES'}
TIMEOUT $upssettings{'TIMEOUT'}
NOLOGON $upssettings{'NOLOGON'}
KILLDELAY $upssettings{'KILLDELAY'}
#
## Configuration Directives used by the Network Information Server
#
EVENTSFILE $upssettings{'EVENTSFILE'}
EVENTSFILEMAX $upssettings{'EVENTSFILEMAX'}
#
## Configuration Directives used for sharing informations via network
#
UPSCLASS standalone
UPSMODE disable
NETTIME $upssettings{'NETTIME'}
#
## Configuration Directives used to Control System Logging
#
STATTIME $upssettings{'STATTIME'}
STATFILE $upssettings{'STATFILE'}
LOGSTATS $upssettings{'LOGSTATS'}
DATATIME $upssettings{'DATATIME'}
END
;
}
close FILE;

if ($upssettings{'UPSNAME'} eq '' || $upssettings{'FQDN'} eq '')
{
	$errormessage = $Lang::tr{'ups_error'};
	goto ERROR;
}
if ($upssettings{'UPSCLASS'} eq 'nisslave' && $upssettings{'MASTER'} eq '')
{
	$errormessage = $Lang::tr{'ups_error'};
	goto ERROR;
}
if ($upssettings{'ENABLE'} eq 'on')
{
	system('/bin/touch', "${General::swroot}/apcupsd/enable_addon");
}
else
{
	unlink "${General::swroot}/apcupsd/enable_addon";
}

}

############################################################################################################################

if ($upssettings{'ACTION'} eq $Lang::tr{'ups_stop'})
{
	unlink "${General::swroot}/apcupsd/enable_addon";
	&General::log($Lang::tr{'ups_server_disabled'});
	system('/usr/local/bin/restartups', 'stop');
}

############################################################################################################################

isrunning ('apcupsd');

if ($upssettings{'ACTION'} eq $Lang::tr{'ups_start'})
{
	if ($upssettings{'ENABLE'} eq 'off')
		{
		$errormessage = $Lang::tr{'ups_err_upsenable'};
		goto ERROR;
		}
	if ($upssettings{'UPSNAME'} eq '' || $upssettings{'FQDN'} eq '')
		{
		$errormessage = $Lang::tr{'ups_error'};
		goto ERROR;
		}
	if ($upssettings{'UPSCLASS'} eq 'nisslave' && $upssettings{'MASTER'} eq '')
		{
		$errormessage = $Lang::tr{'ups_error'};
		goto ERROR;
		}
	if ($pidalive)
		{	
		$errormessage = $Lang::tr{'ups_err_start'};
		goto ERROR;
		}
	else
		{
		system('/bin/touch', "${General::swroot}/apcupsd/enable_addon");
		&General::log($Lang::tr{'ups_server_enabled'});
		system('/usr/local/bin/restartups', 'start');
		system('/bin/sleep', '5');
		}
}

############################################################################################################################

isrunning ('apcupsd');

if ($upssettings{'ACTION'} eq $Lang::tr{'ups_refresh'})
{

if ($pidalive)
{	
$errormessage = $Lang::tr{'ups_err_refresh'};
goto ERROR;
}
else
{
	if ($upssettings{'UPSDEVICE'} eq 'USB') {$upssettings{'DEVICE'} = '/dev/usb/hiddev[0-7]';}
	elsif ($upssettings{'UPSDEVICE'} eq 'COM4')  {$upssettings{'DEVICE'} = '/dev/ttyS3';}
	elsif ($upssettings{'UPSDEVICE'} eq 'COM3')  {$upssettings{'DEVICE'} = '/dev/ttyS2';}
	elsif ($upssettings{'UPSDEVICE'} eq 'COM2')  {$upssettings{'DEVICE'} = '/dev/ttyS1';}
	elsif ($upssettings{'UPSDEVICE'} eq 'COM1')  {$upssettings{'DEVICE'} = '/dev/ttyS0';}
	else  {$upssettings{'DEVICE'} = $upssettings{'UPSDEVICE'};}

	if ($upssettings{'UPSMODEL'} eq 'smartups')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsoffice')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupses')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupscs')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupscsusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsesusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsprousb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupscses')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupspro')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupspropnp')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'newbackupspro')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsofficeusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backups') {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'smartupsusb')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'smartupsvs')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'powerstack')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'matrixups')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'smartbackupspro')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'shareadv')  {$upssettings{'UPSTYPE'} = 'apcsmart';}
	elsif ($upssettings{'UPSMODEL'} eq 'sharebasic')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'netups')  {$upssettings{'UPSTYPE'} = 'dumb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsrs')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'backupsxs')  {$upssettings{'UPSTYPE'} = 'usb';}
	elsif ($upssettings{'UPSMODEL'} eq 'snmp')  {$upssettings{'UPSTYPE'} = 'snmp';}
	else {$upssettings{'UPSTYPE'} = 'apcsmart';}

&General::writehash("${General::swroot}/apcupsd/settings", \%upssettings);
}
}

############################################################################################################################

ERROR:

if ($errormessage) 
{
	$upssettings{'VALID'} = 'no'; 
}
else 
{
	$upssettings{'VALID'} = 'yes';
}

############################################################################################################################

isrunning ('apcupsd');

if ( ($pidalive eq '0') || ($upssettings{'ACTION'} eq $Lang::tr{'ups_config'}) ) {

&General::readhash("${General::swroot}/apcupsd/settings", \%upssettings);

$checked{'ENABLE'}{'off'} = '';
$checked{'ENABLE'}{'on'} = '';
$checked{'ENABLE'}{$upssettings{'ENABLE'}} = "checked='checked'";

$checked{'HTTPS'}{'off'} = '';
$checked{'HTTPS'}{'on'} = '';
$checked{'HTTPS'}{$upssettings{'HTTPS'}} = "checked='checked'";

$checked{'HTTP'}{'off'} = '';
$checked{'HTTP'}{'on'} = '';
$checked{'HTTP'}{$upssettings{'HTTP'}} = "checked='checked'";

$checked{'IPCOP'}{'off'} = '';
$checked{'IPCOP'}{'on'} = '';
$checked{'IPCOP'}{$upssettings{'IPCOP'}} = "checked='checked'";

$checked{'NISONGREEN'}{'off'} = '';
$checked{'NISONGREEN'}{'on'} = '';
$checked{'NISONGREEN'}{$upssettings{'NISONGREEN'}} = "checked='checked'";

$checked{'KILLPOWER'}{'off'} = '';
$checked{'KILLPOWER'}{'on'} = '';
$checked{'KILLPOWER'}{$upssettings{'KILLPOWER'}} = "checked='checked'";

$selected{'UPSMODEL'}{'smartups'} = '';
$selected{'UPSMODEL'}{'backups'} = '';
$selected{'UPSMODEL'}{'backupsusb'} = '';
$selected{'UPSMODEL'}{'backupsoffice'} = '';
$selected{'UPSMODEL'}{'backupses'} = '';
$selected{'UPSMODEL'}{'backupscs'} = '';
$selected{'UPSMODEL'}{'backupscsusb'} = '';
$selected{'UPSMODEL'}{'backupsesusb'} = '';
$selected{'UPSMODEL'}{'backupsprousb'} = '';
$selected{'UPSMODEL'}{'backupscses'} = '';
$selected{'UPSMODEL'}{'backupupspro'} = '';
$selected{'UPSMODEL'}{'backupspropnp'} ='';
$selected{'UPSMODEL'}{'newbackupspro'} ='';
$selected{'UPSMODEL'}{'backupsofficeusb'} = '';
$selected{'UPSMODEL'}{'smartupsusb'} = '';
$selected{'UPSMODEL'}{'smartupsvs'} = '';
$selected{'UPSMODEL'}{'powerstack'} = '';
$selected{'UPSMODEL'}{'matrixups'} = '';
$selected{'UPSMODEL'}{'smartbackupspro'} = '';
$selected{'UPSMODEL'}{'shareadv'} = '';
$selected{'UPSMODEL'}{'sharebasic'} = '';
$selected{'UPSMODEL'}{'netups'} ='';
$selected{'UPSMODEL'}{'backupsrs'} = '';
$selected{'UPSMODEL'}{'backupsxs'} = '';
$selected{'UPSMODEL'}{'snmp'} = '';
$selected{'UPSMODEL'}{$upssettings{'UPSMODEL'}} = "selected='selected'";

$selected{'UPSDEVICE'}{'COM1'} = '';
$selected{'UPSDEVICE'}{'COM2'} = '';
$selected{'UPSDEVICE'}{'COM3'} = '';
$selected{'UPSDEVICE'}{'COM4'} = '';
$selected{'UPSDEVICE'}{'USB'} = '';
$selected{'UPSDEVICE'}{$upssettings{'UPSDEVICE'}} = "selected='selected'";

$selected{'UPSCABLE'}{'smart'} = '';
$selected{'UPSCABLE'}{'usb'} = '';
$selected{'UPSCABLE'}{'ether'} = '';
$selected{'UPSCABLE'}{'940-0020B'} = '';
$selected{'UPSCABLE'}{'940-0020C'} = '';
$selected{'UPSCABLE'}{'940-0023A'} = '';
$selected{'UPSCABLE'}{'940-0024B'} = '';
$selected{'UPSCABLE'}{'940-0024C'} = '';
$selected{'UPSCABLE'}{'940-0024G'} = '';
$selected{'UPSCABLE'}{'940-0095A'} = '';
$selected{'UPSCABLE'}{'940-0095B'} = '';
$selected{'UPSCABLE'}{'940-0095C'} = '';
$selected{'UPSCABLE'}{'940-0119A'} = '';
$selected{'UPSCABLE'}{'940-0127A'} = '';
$selected{'UPSCABLE'}{'940-0127B'} = '';
$selected{'UPSCABLE'}{'940-0127C'} = '';
$selected{'UPSCABLE'}{'940-0128A'} = '';
$selected{'UPSCABLE'}{'940-1524C'} = '';
$selected{'UPSCABLE'}{$upssettings{'UPSCABLE'}} = "selected='selected'";

$selected{'UPSCLASS'}{'standalone'} = '';
$selected{'UPSCLASS'}{'nisslave'} = '';
$selected{'UPSCLASS'}{$upssettings{'UPSCLASS'}} = "selected='selected'";

$selected{'UPSSNMPTYPE'}{'APC'} = '';
$selected{'UPSSNMPTYPE'}{'APC_NOTRAP'} = '';
$selected{'UPSSNMPTYPE'}{'RFC'} = '';
$selected{'UPSSNMPTYPE'}{$upssettings{'UPSSNMPTYPE'}} = "selected='selected'";

&Header::openpage($Lang::tr{'ups_settings'}, 1, '');

&Header::openbigbox('100%', 'left', '');

if ($errormessage) {
	&Header::openbox('100%', 'left', $Lang::tr{'ups_errormessage'});
	print "<font color='#FF0000'>$errormessage</font>";
	&Header::closebox();
}

if (($addonversion lt $addoncheck) && (-e $addonupdate)) { unlink($addonupdate); }

if (!-e $addonupdate) {
	&Header::openbox('100%', 'left', $Lang::tr{'ups_update_msg'});
	print "<table width='100%'>";
	print "<tr>";
	print "<td><font color='#0000FF'>$Lang::tr{'ups_update_info'}</font><a href='http://www.ipcop.h-loit.de' target='_blank'><font color='#0000FF'> http://www.ipcop.h-loit.de !</font></a></td>";
	print "</tr>";
	print "</table>";
	&Header::closebox();
}

print "<form method='post' action='$ENV{'SCRIPT_NAME'}'>";

&Header::openbox('100%', 'left', $Lang::tr{'ups_server_info'});

print <<END
<table width='100%' cellspacing='0' cellpadding='0'>
	<tr>
		<td width='25%'>
			<table width='100%' align='right'cellspacing='0' cellpadding='0'>
				<tr>
END
;

my $key = '';
foreach $key (sort keys %servicenames)
{
	print "<td align='center'><b>$key</b></td>";
	my $shortname = $servicenames{$key};
	my $status = &isrunning($shortname);
	print "$status";
}

print <<END
				</tr>
			</table>
		</td>
		<td width='75%'>
			<table width='85%' cellspacing='0' cellpadding='0' border='0' align='right'>
				<tr>
END
;

isrunning ('apcupsd');

if ($pidalive)
{

	if ( ! -e "/var/ipcop/apcupsd/enable_graphs" ) {
		print "<td>&nbsp;</td>";
	}
	else
	{
		print "<td align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_graphs'}'></td>";
	}
		print "<td align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_status'}'></td>";
}
else
{
		print "<td>&nbsp;</td>";
		print "<td>&nbsp;</td>";
}

print <<END
	<td align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_log'}'></td>
	<td align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_help'}'></td>
	<td align='right'><small><a href="http://www.ipcop.h-loit.de" target="_blank"><font color='${Header::table1colour}'><b>$addonname Ver. $addonversion</b></font></a></small></td>
				</tr>
			</table>
		</td>
	</tr>
</table>
END
;

END
;

&Header::closebox();

&Header::openbox('100%', 'left', $Lang::tr{'ups_settings'});

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_mainsettings'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>Apcupsd Version:</td>
	<td align='left'><font color="339933"><b>&nbsp;$apcupsdver</b></font></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_enabled'}</td>
	<td align='left'><input type='checkbox' name='ENABLE' $checked{'ENABLE'}{'on'}></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_name'}:</td>
	<td align='left'><input type='text' name='UPSNAME' value='$upssettings{'UPSNAME'}' size='25'></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
</table>
END
;

if ($upssettings{'UPSCLASS'} eq 'standalone')
{

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'>$Lang::tr{'ups_fqdn'}:</td>
	<td width='30%' align='left'><input type='text' name='FQDN' value='$upssettings{'FQDN'}' size='25'>&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
</table>
END
;
}

if ($upssettings{'UPSCLASS'} eq 'nisslave')
{

print <<END

END
;
}

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'>$Lang::tr{'ups_modus'}:</td>
	<td width='30%' align='left'><select size='1' name='UPSCLASS' size='22'>
		<option value='standalone' $selected{'UPSCLASS'}{'standalone'}>standalone</option>
		<option value='nisslave' $selected{'UPSCLASS'}{'nisslave'}>nisslave</option>
		</select></td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
</table>
END
;

if ($upssettings{'UPSCLASS'} eq 'standalone')
{

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'>$Lang::tr{'ups_type'}:</td>
	<td width='30%' align='left'><select size='1' name='UPSMODEL' size='25'>
		<option value='snmp' $selected{'UPSMODEL'}{'snmp'}>SNMP</option>
		<option value='backups' $selected{'UPSMODEL'}{'backups'}>BackUPS</option>
		<option value='backupsusb' $selected{'UPSMODEL'}{'backupsusb'}>BackUPS USB</option>
		<option value='backupsoffice' $selected{'UPSMODEL'}{'backupsoffice'}>BackUPS Office</option>
		<option value='backupsofficeusb' $selected{'UPSMODEL'}{'backupsofficeusb'}>BackUPS Office USB</option>
		<option value='backupses' $selected{'UPSMODEL'}{'backupses'}>BackUPS ES</option>
		<option value='backupsesusb' $selected{'UPSMODEL'}{'backupsesusb'}>BackUPS ES USB</option>
		<option value='backupscs' $selected{'UPSMODEL'}{'backupscs'}>BackUPS CS</option>
		<option value='backupscsusb' $selected{'UPSMODEL'}{'backupscsusb'}>BackUPS CS USB</option>
		<option value='backupscses' $selected{'UPSMODEL'}{'backupscses'}>BackUPS CS / ES</option>
		<option value='backupsrs' $selected{'UPSMODEL'}{'backupsrs'}>BackUPS RS USB</option>
		<option value='backupsxs' $selected{'UPSMODEL'}{'backupsxs'}>BackUPS XS USB</option>
		<option value='backupspro' $selected{'UPSMODEL'}{'backupspro'}>BackUPS Pro</option>
		<option value='backupspro' $selected{'UPSMODEL'}{'backupsprousb'}>BackUPS Pro USB</option>
		<option value='backupspropnp' $selected{'UPSMODEL'}{'backupspropnp'}>BackUPS Pro PNP</option>
		<option value='matrixups' $selected{'UPSMODEL'}{'matrixups'}>Matrix UPS</option>
		<option value='netups' $selected{'UPSMODEL'}{'netups'}>NetUPS</option>
		<option value='newbackupspro' $selected{'UPSMODEL'}{'newbackupspro'}>New BackUPS Pro</option>
		<option value='powerstack' $selected{'UPSMODEL'}{'powerstack'}>PowerStack 450</option>
		<option value='shareadv' $selected{'UPSMODEL'}{'shareadv'}>ShareUPS Adv. Port</option>
		<option value='sharebasic' $selected{'UPSMODEL'}{'sharebasic'}>ShareUPS Basic Port</option>
		<option value='smartups' $selected{'UPSMODEL'}{'smartups'}>SmartUPS</option>
		<option value='smartupsusb' $selected{'UPSMODEL'}{'smartupsusb'}>SmartUPS USB</option>
		<option value='smartupsvs' $selected{'UPSMODEL'}{'smartupsvs'}>SmartUPS VS</option>
		<option value='smartbackupspro' $selected{'UPSMODEL'}{'smartbackupspro'}>Smarter BackUPS Pro</option>
		</select>&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
</table>
END
;

}
if ($upssettings{'UPSCLASS'} eq 'nisslave')
{

print <<END

END
;
}

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td>&nbsp;</td>
</tr>
</table>
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%'>&nbsp;</td>
	<td width='30%' align='left'><input type='submit' name='ACTION' value='$Lang::tr{'ups_refresh'}'>&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
</table>
END
;

print "&nbsp;";
print "<hr noshade align='center' width='100%' size='1'>";
print "&nbsp;";

if ($upssettings{'UPSTYPE'} eq 'usb')
{

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_connections'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_cable'}:</td>
	<td align='left'><select size='1' name='UPSCABLE' size='10'>
		<option value='usb' $selected{'UPSCABLE'}{'usb'}>usb</option>
		<option value='940-0127A' $selected{'UPSCABLE'}{'940-0127A'}>940-0127A</option>
		<option value='940-0127B' $selected{'UPSCABLE'}{'940-0127B'}>940-0127B</option>
		<option value='940-0127C' $selected{'UPSCABLE'}{'940-0127C'}>940-0127C</option>
		</select></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_device'}:</td>
	<td align='left'><select size='1' name='UPSDEVICE' size='10'>
		<option $selected{'UPSDEVICE'}{'USB'}>USB</option>
		</select></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
</table>
END
;
}

if ($upssettings{'UPSTYPE'} eq 'dumb')
{

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_connections'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_cable'}:</td>
	<td align='left'><select size='1' name='UPSCABLE' size='10'>
		<option value='940-0020B' $selected{'UPSCABLE'}{'940-0020B'}>940-0020B</option>
		<option value='940-0020C' $selected{'UPSCABLE'}{'940-0020C'}>940-0020C</option>
		<option value='940-0023A' $selected{'UPSCABLE'}{'940-0023A'}>940-0023A</option>
		<option value='940-0119A' $selected{'UPSCABLE'}{'940-0119A'}>940-0119A</option>
		<option value='940-0128A' $selected{'UPSCABLE'}{'940-0128A'}>940-0128A</option>
		</select></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_device'}:</td>
	<td align='left'><select size='1' name='UPSDEVICE' size='10'>
		<option $selected{'UPSDEVICE'}{'COM1'}>COM1</option>
		<option $selected{'UPSDEVICE'}{'COM2'}>COM2</option>
		<option $selected{'UPSDEVICE'}{'COM3'}>COM3</option>
		<option $selected{'UPSDEVICE'}{'COM4'}>COM4</option>
		</select></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
</table>
END
;
}

if ($upssettings{'UPSTYPE'} eq 'apcsmart')
{

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_connections'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_cable'}:</td>
	<td align='left'><select size='1' name='UPSCABLE' size='10'>
		<option value='smart' $selected{'UPSCABLE'}{'smart'}>smart</option>
		<option value='940-0020B' $selected{'UPSCABLE'}{'940-0020B'}>940-0020B</option>
		<option value='940-0020C' $selected{'UPSCABLE'}{'940-0020C'}>940-0020C</option>
		<option value='940-0023A' $selected{'UPSCABLE'}{'940-0023A'}>940-0023A</option>
		<option value='940-0024B' $selected{'UPSCABLE'}{'940-0024B'}>940-0024B</option>
		<option value='940-0024C' $selected{'UPSCABLE'}{'940-0024C'}>940-0024C</option>
		<option value='940-0024G' $selected{'UPSCABLE'}{'940-0024G'}>940-0024G</option>
		<option value='940-0095A' $selected{'UPSCABLE'}{'940-0095A'}>940-0095A</option>
		<option value='940-0095B' $selected{'UPSCABLE'}{'940-0095B'}>940-0095B</option>
		<option value='940-0095C' $selected{'UPSCABLE'}{'940-0095C'}>940-0095C</option>
		<option value='940-0119A' $selected{'UPSCABLE'}{'940-0119A'}>940-0119A</option>
		<option value='940-0128A' $selected{'UPSCABLE'}{'940-0128A'}>940-0128A</option>
		<option value='940-1524C' $selected{'UPSCABLE'}{'940-1524C'}>940-1524C</option>
		</select></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_device'}:</td>
	<td align='left'><select size='1' name='UPSDEVICE' size='10'>
		<option $selected{'UPSDEVICE'}{'COM1'}>COM1</option>
		<option $selected{'UPSDEVICE'}{'COM2'}>COM2</option>
		<option $selected{'UPSDEVICE'}{'COM3'}>COM3</option>
		<option $selected{'UPSDEVICE'}{'COM4'}>COM4</option>
		</select></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
</table>
END
;
}

if ($upssettings{'UPSTYPE'} eq 'snmp')
{

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_connections'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
	<input type='hidden' name='UPSCABLE' value='smart'>
<tr>
	<td align='right'>$Lang::tr{'ups_snmp_ip'}:</td>
	<td align='left' colspan='3'><input type='text' size='14' name='UPSSNMPIP' value='$upssettings{'UPSSNMPIP'}'></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_snmp_port'}:</td>
	<td align='left' colspan='3'><input type='text' size='14' name='UPSSNMPPORT' value='$upssettings{'UPSSNMPPORT'}'></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_snmp_type'}:</td>
	<td align='left'><select size='1' name='UPSSNMPTYPE' size='14'>
		<option value='APC' $selected{'UPSSNMPTYPE'}{'APC'}>APC</option>
		<option value='APC_NOTRAP' $selected{'UPSSNMPTYPE'}{'APC_NOTRAP'}>APC_NOTRAP</option>
		<option value='RFC' $selected{'UPSSNMPTYPE'}{'RFC'}>RFC</option>
		</select></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_snmp_community'}:</td>
	<td align='left' colspan='3'><input type='text' size='14' name='UPSSNMPCOMMUNITY' value='$upssettings{'UPSSNMPCOMMUNITY'}'></td>
</tr>
</table>
END
;
}

if ($upssettings{'UPSCLASS'} eq 'nisslave')
{

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_connections'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%' align='right'><b>$Lang::tr{'ups_downsettings'}:</b></td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_cable'}:</td>
	<td align='left'><select size='1' name='UPSCABLE' size='10'>
		<option value='ether' $selected{'UPSCABLE'}{'ether'}>ether</option>
		</select></td>
	<td align='right'>$Lang::tr{'ups_onbatterydelay'}:</td>
	<td align='left'><input type='text' name='ONBATTERYDELAY' value='$upssettings{'ONBATTERYDELAY'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_nismaster'}:</td>
	<td align='left'><input type='text' name='MASTER' value='$upssettings{'MASTER'}' size='22'>&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
	<td align='right'>$Lang::tr{'ups_timeout'}:</td>
	<td align='left'><input type='text' name='TIMEOUT' value='$upssettings{'TIMEOUT'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_nismasterport'}:</td>
	<td align='left'><input type='text' name='NISPORT' value='$upssettings{'NISPORT'}' size='8'></td>
	<td align='right'>$Lang::tr{'ups_batterylevel'}:</td>
	<td align='left'><input type='text' name='BATTERYLEVEL' value='$upssettings{'BATTERYLEVEL'}' size='4'> %</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_nisnettime'}:</td>
	<td align='left'><input type='text' name='NETTIME' value='$upssettings{'NETTIME'}' size='8'></td>
	<td align='right'>$Lang::tr{'ups_minutes'}:</td>
	<td align='left'><input type='text' name='MINUTES' value='$upssettings{'MINUTES'}' size='4'> $Lang::tr{'ups_minuts'}</td>
</tr>
<tr>
	<td>&nbsp;</td>
</tr>
</table>
END
;

print "&nbsp;";
print "<hr noshade align='center' width='100%' size='1'>";
print "&nbsp;";

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_monitoring'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_ipcopnis'}</td>
	<td align='left'><input type='checkbox' name='IPCOP' $checked{'IPCOP'}{'on'}></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_http'}:</td>
	<td align='left'><input type='checkbox' name='HTTP' $checked{'HTTP'}{'on'}></td>
	<td align='right'>$Lang::tr{'ups_multimon'}:</td>
	<td align='left'><input type='text' name='MULTIMON' value='$upssettings{'MULTIMON'}' size='22'></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_httpport'}:</td>
	<td align='left'><input type='text' name='HTTPPORT' value='$upssettings{'HTTPPORT'}' size='8'></td>
	<td align='right'>$Lang::tr{'ups_upsstats'}:</td>
	<td align='left'><input type='text' name='UPSSTATS' value='$upssettings{'UPSSTATS'}' size='22'></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_https'}:</td>
	<td align='left'><input type='checkbox' name='HTTPS' $checked{'HTTPS'}{'on'}></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_httpsport'}:</td>
	<td align='left'><input type='text' name='HTTPSPORT' value='$upssettings{'HTTPSPORT'}' size='8'></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
</table>
END
;
}

if ($upssettings{'UPSCLASS'} eq 'standalone')
{
if ($upssettings{'UPSTYPE'} eq 'apcsmart' || $upssettings{'UPSTYPE'} eq 'usb' || $upssettings{'UPSTYPE'} eq 'snmp')
{

print "&nbsp;";
print "<hr noshade align='center' width='100%' size='1'>";
print "&nbsp;";

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_downsettings'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%' align='right'><b>$Lang::tr{'ups_usersettings'}:</b></td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_onbatterydelay'}:</td>
	<td align='left'><input type='text' name='ONBATTERYDELAY' value='$upssettings{'ONBATTERYDELAY'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}</td>
	<td align='right'>$Lang::tr{'ups_annoydelay'}:</td>
	<td align='left'><input type='text' name='ANNOYDELAY' value='$upssettings{'ANNOYDELAY'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_timeout'}:</td>
	<td align='left'><input type='text' name='TIMEOUT' value='$upssettings{'TIMEOUT'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
	<td align='right'>$Lang::tr{'ups_annoy'}:</td>
	<td align='left'><input type='text' name='ANNOY' value='$upssettings{'ANNOY'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_batterylevel'}:</td>
	<td align='left'><input type='text' name='BATTERYLEVEL' value='$upssettings{'BATTERYLEVEL'}' size='4'> %</td>
	<td align='right'>$Lang::tr{'ups_nisongreen1'}<strong><font color="339933"> eth0</font></strong>$Lang::tr{'ups_nisongreen2'}:</td>
	<td align='left'><input type='checkbox' name='NISONGREEN' $checked{'NISONGREEN'}{'on'}>&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_minutes'}:</td>
	<td align='left'><input type='text' name='MINUTES' value='$upssettings{'MINUTES'}' size='4'> $Lang::tr{'ups_minuts'}</td>
	<td align='right'>$Lang::tr{'ups_nisport'}:</td>
	<td align='left'><input type='text' name='NISPORT' value='$upssettings{'NISPORT'}' size='4'></td>
</tr>
<tr>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_killpower'}</td>
	<td align='left'><input type='checkbox' name='KILLPOWER' $checked{'KILLPOWER'}{'on'}></td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
</table>
END
;
}

elsif ($upssettings{'UPSTYPE'} eq 'dumb')
{
print "&nbsp;";
print "<hr noshade align='center' width='100%' size='1'>";
print "&nbsp;";

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'><b>$Lang::tr{'ups_downsettings'}:</b></td>
	<td width='30%'>&nbsp;</td>
	<td width='20%' align='right'><b>$Lang::tr{'ups_usersettings'}:</b></td>
	<td width='30%'>&nbsp;</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'ups_timeout'}:</td>
	<td align='left'><input type='text' name='TIMEOUT' value='$upssettings{'TIMEOUT'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
	<td align='right'>$Lang::tr{'ups_annoydelay'}:</td>
	<td align='left'><input type='text' name='ANNOYDELAY' value='$upssettings{'ANNOYDELAY'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td align='right'>$Lang::tr{'ups_annoy'}:</td>
	<td align='left'><input type='text' name='ANNOY' value='$upssettings{'ANNOY'}' size='4'>&nbsp;$Lang::tr{'ups_seconds'}</td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td align='right'>$Lang::tr{'ups_nisongreen1'}<strong><font color="339933"> eth0</font></strong>$Lang::tr{'ups_nisongreen2'}:</td>
	<td align='left'><input type='checkbox' name='NISONGREEN' $checked{'NISONGREEN'}{'on'}>&nbsp;&nbsp;<a href='/cgi-bin/ups.cgi?action=$Lang::tr{'ups_help'}'><img src='/images/pin.gif' title='$Lang::tr{'ups_info'}' alt='$Lang::tr{'ups_info'}'></img></a></td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td align='right'>$Lang::tr{'ups_nisport'}:</td>
	<td align='left'><input type='text' name='NISPORT' value='$upssettings{'NISPORT'}' size='4'></td>
</tr>
</table>
END
;
}
}

print "&nbsp;";
print "<hr noshade align='center' width='100%' size='1'>";
print "&nbsp;";

if ($pidalive)
{	
print <<END
<table align='center' width='50%' cellpadding='1'>
<tr>
	<td width='25%'>&nbsp;</td>
	<td width='25%'>&nbsp;</td>
</tr>
<tr>
	<td width='25%'>&nbsp;</td>
	<td width='25%' align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_stop'}'></td>
</tr>
</table>
END
;
} else {
print <<END
<table align='center' width='50%' cellpadding='1'>
<tr>
	<td width='25'>&nbsp;</td>
	<td width='25'>&nbsp;</td>
</tr>
<tr>
	<td width='25%' align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_save'}'></td>
	<td width='25%' align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_start'}'></td>
</tr>
</table>
END
;
}

print "</form>";

&Header::closebox();

if (stat($mailclient))  
{

&General::readhash("${General::swroot}/apcupsd/mailsettings", \%upsmailsettings);

$checked{'MAIL'}{'off'} = '';
$checked{'MAIL'}{'on'} = '';
$checked{'MAIL'}{$upsmailsettings{'MAIL'}} = "checked='checked'";

&Header::openbox('100%', 'left', $Lang::tr{'upsmail_mail'});

print <<END
<form method='post'>
<table width='100%' cellpadding='1'>
<tr>
	<td width='20%' align='right'>$Lang::tr{'upsmail_enabled'}</td>
	<td width='30%' align='left'><input type='checkbox' name='MAIL' $checked{'MAIL'}{'on'}></td>
	<td width='20%'>&nbsp;</td>
	<td width='30%'>&nbsp;</td>
</tr>
</table>
END
;

if ($upsmailsettings{'MAIL'} eq 'on')
{
print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'upsmail_mailsender'}:</td>
	<td align='left'><input type='text' name='MAILFROM' value='$upsmailsettings{'MAILFROM'}' size='40' tabindex='1'></td>
	<td align='right'>$Lang::tr{'upsmail_mailserver'}:</td>
	<td align='left'><input type='text' name='MAILSERVER' value='$upsmailsettings{'MAILSERVER'}' size='25' tabindex='4'></td>
<tr>
	<td align='right'>$Lang::tr{'upsmail_mailto1'}:</td>
	<td align='left'><input type='text' name='MAILTO1' value='$upsmailsettings{'MAILTO1'}' size='40' tabindex='2'></td>
	<td align='right'>$Lang::tr{'upsmail_mailsmtpport'}:</td>
	<td align='left'><input type='text' name='MAILSMTP' value='$upsmailsettings{'MAILSMTP'}' size='2' tabindex='5'></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'upsmail_mailto2'}:</td>
	<td align='left'><input type='text' name='MAILTO2' value='$upsmailsettings{'MAILTO2'}' size='40' tabindex='3'></td>
	<td align='right'>$Lang::tr{'upsmail_mailserveruser'}:</td>
	<td align='left'><input type='text' name='MAILNAME' value='$upsmailsettings{'MAILNAME'}' size='25' tabindex='6'></td>
</tr>
<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td align='right'>$Lang::tr{'upsmail_mailserverpw'}:</td>
	<td align='left'><input type='password' name='MAILPW' value='$upsmailsettings{'MAILPW'}' tabindex='7'></td>
</tr>
</table>
END
;
}
else
{
print <<END

END
;
}
print <<END
<table align='center' width='50%' cellpadding='1'>
<tr>
	<td width='25%'>&nbsp;</td>
	<td width='25%'>&nbsp;</td>
</tr>
<tr>
	<td width='25%' align='center'><input type='HIDDEN' name='ACTION' value='$Lang::tr{'upsmailsave'}'><INPUT TYPE='submit' NAME='DUMMY' VALUE='$Lang::tr{'ups_save'}'></td></form>
END
;

if (($upsmailsettings{'MAIL'} eq 'on' && $upsmailsettings{'MAILFROM'} ne '' && $upsmailsettings{'MAILSERVER'} ne '' && $upsmailsettings{'MAILSMTP'} ne '') && ($upsmailsettings{'MAILTO1'} ne '' || $upsmailsettings{'MAILTO2'} ne ''))
{
print <<END
	<td width='25%' align='center'><form method='post'><INPUT TYPE='SUBMIT' NAME='ACTION' VALUE='$Lang::tr{'upsmailtest'}'></form></td>
</tr>
</table>
END
;
}
else
{
print <<END
	<td width='25%'>&nbsp;</td>
</tr>
</table>
END
;
}

&Header::closebox();
}

if (((stat($smbclient)) || (stat($msgclient))) && (stat($ipfile)))
{	

&Header::openbox('100%', 'left', $Lang::tr{'ups_msg_client'});

my $buttontext = $Lang::tr{'add'};
if ($cgiparams{'ACTION'} eq $Lang::tr{'edit'}) { $buttontext = $Lang::tr{'update'}; }

print "<form method='post' action='$ENV{'SCRIPT_NAME'}'>";

print <<END
<table width='100%' cellpadding='1'>
<tr>
	<td>&nbsp;</td>
</tr>
<tr>
	<td width='20%' align='right'>$Lang::tr{'host ip'}:</td>
	<td width='30%' align='left'><input type='text' name='IPADDR' value='$cgiparams{'IPADDR'}' size='25' tabindex='9'></td>
END
;

if ((stat($smbclient)) && (stat($ipfile)))
{	
	print "<td width='50%' align='left' rowspan='2' valign='top'><font color='#339933'><b>$Lang::tr{'ups_smbclienthint'}</b></font></td>";
}
elsif ((stat($msgclient)) && (stat($ipfile)))
{
	print "<td width='50%' align='left' rowspan='2' valign='top'><font color='#339933'><b>$Lang::tr{'ups_msgclienthint'}</b></font></td>";
}

print <<END
</tr>
<tr>
	<td align='right'>$Lang::tr{'hostname'}:</td>
	<td align='left'><input type='text' name='HOSTNAME' value='$cgiparams{'HOSTNAME'}' size='25' tabindex='10'></td>
</tr>
<tr>
	<td align='right'>$Lang::tr{'domain name'}:</td>
	<td align='left'><input type='text' name='DOMAINNAME' value='$cgiparams{'DOMAINNAME'}' size='25' tabindex='11'></td>
	<td width='50%' align='left'><b>$Lang::tr{'ups_msgclient_down'}</b>&nbsp;&nbsp;<a href="/ups/IPCopWMC.zip"><img align='absmiddle' src='/images/floppy.gif' alt='$Lang::tr{'ups_msgclient_down'}' title='$Lang::tr{'ups_msgclient_down'}' /></a></TD>
</tr>
<tr>
	<td>&nbsp;</td>
</tr>
<tr>
	<td width='20%'>&nbsp;</td>
	<td width='30%' align='left'><input type='hidden' name='ACTION' value='$Lang::tr{'add'}'><input type='submit' name='SUBMIT' value='$buttontext' tabindex='12'></td>
</tr>
</table>
END
;

if ($cgiparams{'ACTION'} eq $Lang::tr{'edit'}) {
	print "<input type='hidden' name='EDITING' value='$cgiparams{'KEY1'}'>";
} else {
	print "<input type='hidden' name='EDITING' value='no'>";
}

print "</form>";

print "&nbsp;";
print "<hr noshade align='center' width='100%' size='1'>";
print "&nbsp;";

print <<END
<table width='100%' cellpadding='1'>
</table>
END
;
print <<END
<div align='center'>
END
;
open (FILE, "$ipfile");
my @current1 = <FILE>;
close (FILE);

print <<END
<table width='100%'>
<tr>
<td align='center'><b>$Lang::tr{'host ip'}</b></td>
<td align='center'><b>$Lang::tr{'hostname'}</b></td>
<td align='center'><b>$Lang::tr{'domain name'}</b></td>
</tr>
END
;

my $id = 0;
my $ipaddr = ();
my $hostname = ();
my $domainname = ();

my @hostsarray = &General::srtarray('2','a','asc',@current1);
foreach my $line (@hostsarray)
{
	$id++;
	chomp($line);
	my @temp = split(/\,/,$line);
	my $key = $temp[0];
	my $ipaddr = $temp[1];
	my $hostname = $temp[2];
	my $domainname = $temp[3];

	if ($cgiparams{'ACTION'} eq $Lang::tr{'edit'} && $cgiparams{'KEY1'} eq $key) {
		print "<tr bgcolor='$Header::colouryellow'>\n";
	} elsif ($id % 2) {
		print "<tr bgcolor='$Header::table1colour'>\n";
	} else {
		print "<tr bgcolor='$Header::table2colour'>\n";
	}
	print "<td align='center'>$ipaddr</td>\n";
	print "<td align='center'>$hostname</td>\n";
	print "<td align='center'>$domainname</td>\n";

print<<END
<td align='center'>
	<form method='post' name='frm$temp[0]b' action='$ENV{'SCRIPT_NAME'}'>
	<input type='hidden' name='ACTION' value='$Lang::tr{'edit'}' />
	<input type='image' name='$Lang::tr{'edit'}' src='/images/edit.gif' alt='$Lang::tr{'edit'}' title='$Lang::tr{'edit'}' />
	<input type='hidden' name='KEY1' value='$key' />
	</form>
</td>
<td align='center'>
	<form method='post' name='frm$temp[0]c' action='$ENV{'SCRIPT_NAME'}'>
	<input type='hidden' name='ACTION' value='$Lang::tr{'remove'}' />
	<input type='image' name='$Lang::tr{'remove'}' src='/images/delete.gif' alt='$Lang::tr{'remove'}' title='$Lang::tr{'remove'}' />
	<input type='hidden' name='KEY1' value='$key' />
	</form>
</td>
END
;
print "</tr>\n";
}
print "</table>\n";
print "</div>\n";

if ( ! -z "$ipfile") {
print <<END
<table>
<tr>
	<td>&nbsp;</td>
</tr>
<tr>
	<td class='boldbase'><b>$Lang::tr{'legend'}:</b></td>
	<td>&nbsp;&nbsp;<img src='/images/edit.gif' alt='$Lang::tr{'edit'}'></td>
	<td>$Lang::tr{'edit'}</td>
	<td>&nbsp;&nbsp;<img src='/images/delete.gif' alt='$Lang::tr{'remove'}'></td>
	<td>$Lang::tr{'remove'}</td>
</tr>
</table>
END
;
}
&Header::closebox();
}
&Header::closebigbox();
&Header::closepage();
exit 0;
}

############################################################################################################################

isrunning ('apcupsd');

if ( ($pidalive) || ($upssettings{'ACTION'} eq $Lang::tr{'ups_status'}) ) {

my $output = '';
my $vari = '';
my $running = "${General::swroot}/apcupsd/enable_addon";

&General::readhash("${General::swroot}/apcupsd/settings", \%upssettings);

&Header::getcgihash(\%upssettings);

sub message
{
&Header::openbox('100%', 'left', $Lang::tr{'ups_message'});
print <<END
<div align="center">
<table width='100%' cellpadding='1'>
<td width='100%' align='left'><b>$Lang::tr{'ups_notrunning'}</b></td>
</table>
</div>
END
;
&Header::closebox();
}

sub errormessage {
	if ($errormessage)
		{
			&Header::openbox('100%', 'left', $Lang::tr{'error messages'});
			print "<font class='base'>$errormessage&nbsp;</font>";
			&Header::closebox();
		}
}

sub processes {
	&Header::openbox('100%', 'left', $Lang::tr{'ups_processes'});
	$output = `ps -fH -C apcupsd`;
	print "<pre>$output</pre>";
	&Header::closebox();
}

sub data {
	&Header::openbox('100%', 'left', $Lang::tr{'ups_data'});
	$output = `/bin/cat /var/log/ups/status`;
	print "<pre>$output</pre>";
	&Header::closebox();
}


sub netmon {
	&Header::openbox('100%', 'center', $Lang::tr{'ups_netmon'});
	system ('/home/httpd/cgi-bin/multimon.cgi | sed 1,5d ');
	&Header::closebox();
}

sub netmon_slave_https {
	&Header::openbox('100%', 'center', $Lang::tr{'ups_netmon'});
print <<END
	<div align="center">
		<table border="0" width="715">
			<tr>
				<td><iframe align="center" frameborder="0" src="https://$_[0]:$_[1]$_[2]" width="715" height="165" name=""></iframe></td>
			</tr>
		</table>
	</div>
END
;
&Header::closebox();
}

sub netmon_slave_http {
	&Header::openbox('100%', 'center', $Lang::tr{'ups_netmon'});
print <<END
	<div align="center">
		<table border="0" width="715">
			<tr>
				<td><iframe align="center" frameborder="0" src="http://$_[0]:$_[1]$_[2]" width="715" height="165" name=""></iframe></td>
			</tr>
		</table>
	</div>
END
;
&Header::closebox();
}

sub summary_https {

   my $a = '';
   if ( $_[4] ne '' )
   {
      $a =  $_[4];
      $a = ":".$a;
   }
	&Header::openbox('100%', 'center', $Lang::tr{'ups_summary'});
print <<END
	<div align="center">
		<table border="0" width="840">
			<tr>
				<td><iframe align="center" frameborder="0" src="https://$_[0]:$_[1]$_[2]?host=$_[3]$a&temp=C" width="900" height="625" name=""></iframe></td>
         		</tr>
		</table>
	</div>
END
;
&Header::closebox();
}

sub summary_http {

	&Header::openbox('100%', 'center', $Lang::tr{'ups_summary'});
print <<END
	<div align="center">
		<table border="0" width="840">
			<tr>
				<td><iframe align="center" frameborder="0" src="http://$_[0]:$_[1]$_[2]?temp=C" width="900" height="625" name=""></iframe></td>
        		</tr>
		</table>
	</div>
END
;
&Header::closebox();
}

if ($upssettings{'UPSCLASS'} eq 'standalone')
{
   if ($upssettings{'UPSTYPE'} eq 'apcsmart')
   {
   	$vari = 'master_apc';
   }

   if ($upssettings{'UPSTYPE'} eq 'usb')
   {
   	$vari = 'master_usb';
   }

   if  ($upssettings{'UPSTYPE'} eq 'dumb')
   {
   	$vari = 'master_dumb';
   }
}

if ($upssettings{'UPSCLASS'} eq 'nisslave')
{
   if ($upssettings{'MULTIMON'} ne '' && $upssettings{'UPSSTATS'} ne '')
   {
   	$vari = 'slave_ne_ne';
   }
   if ($upssettings{'MULTIMON'} eq '' && $upssettings{'UPSSTATS'} ne '')
   {
   	$vari = 'slave_eq_ne';
   }
   if ($upssettings{'MULTIMON'} ne '' && $upssettings{'UPSSTATS'} eq '')
   {
   	$vari = 'slave_ne_eq';
   }
}

sub get_https_port {
   open(FILE,"/etc/httpd/conf/httpd.conf");
   my $port = '';

   while (<FILE>) {
     if (/<VirtualHost _default_:(\d+)>/)
      {
         $port = $1;
   	}
   }
   close(FILE);
   return $port;
}

&Header::openpage($Lang::tr{'ups_server_status'}, 1, '');

&Header::openbigbox('100%', 'left');

if (($addonversion lt $addoncheck) && (-e $addonupdate)) { unlink($addonupdate); }

if (!-e $addonupdate) {
	&Header::openbox('100%', 'left', $Lang::tr{'ups_update_msg'});
	print "<table width='100%'>";
	print "<tr>";
	print "<td><font color='#0000FF'>$Lang::tr{'ups_update_info'}</font><a href='http://www.ipcop.h-loit.de' target='_blank'><font color='#0000FF'> http://www.ipcop.h-loit.de!</font></a></td>";
	print "</tr>";
	print "</table>";
	&Header::closebox();
}

print "<form method='post' action='$ENV{'SCRIPT_NAME'}'>";

&Header::openbox('100%', 'left', $Lang::tr{'ups_server_info'});

print <<END
<table width='100%' cellspacing='0' cellpadding='0'>
	<tr>
		<td width='25%'>
			<table width='100%' align='right'cellspacing='0' cellpadding='0'>
				<tr>
END
;

my $key = '';
foreach $key (sort keys %servicenames)
{
	print "<td align='center'><b>$key</b></td>";
	my $shortname = $servicenames{$key};
	my $status = &isrunning($shortname);
	print "$status";
}

print <<END
				</tr>
			</table>
		</td>
		<td width='75%'>
			<table width='85%' cellspacing='0' cellpadding='0' border='0' align='right'>
				<tr>
END
;

if ( ! -e "/var/ipcop/apcupsd/enable_graphs" ) { print "<td>&nbsp;</td>"; }
else { print "<td align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_graphs'}'></td>"; }

print <<END
	<td align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_config'}'></td>
	<td align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_log'}'></td>
	<td align='center'><input type='submit' name='ACTION' value='$Lang::tr{'ups_help'}'></td>
	<td align='right'><small><a href="http://www.ipcop.h-loit.de" target="_blank"><font color='${Header::table1colour}'><b>$addonname Ver. $addonversion</b></font></a></small></td>
				</tr>
			</table>
		</td>
	</tr>
</table>
END
;

END
;
print "</form>";
&Header::closebox();


if (stat($running))

{
errormessage;

if ($upssettings{'UPSCLASS'} eq 'standalone')
{
   netmon;
   summary_https ($upssettings{'FQDN'}, get_https_port , '/cgi-bin/upsstats.cgi', $upssettings{'NISIP'}, $upssettings{'NISPORT'});
}

if (($upssettings{'UPSCLASS'} eq 'nisslave') && ($upssettings{'HTTPS'} eq 'on'))
{
   if ($vari eq 'slave_ne_ne' || $vari eq 'slave_eq_ne')
   {
      netmon_slave_https ($upssettings{'MASTER'}, $upssettings{'HTTPSPORT'},$upssettings{'MULTIMON'});
   }
   if (($upssettings{'IPCOP'} eq 'on') && (($vari eq 'slave_ne_ne') || ($vari eq 'slave_ne_eq')))
   {
      summary_https ($upssettings{'MASTER'}, $upssettings{'HTTPSPORT'}, $upssettings{'UPSSTATS'}, $upssettings{'MASTER'}, $upssettings{'NISPORT'});
   }
   if (($upssettings{'IPCOP'} eq 'off') && (($vari eq 'slave_ne_ne') || ($vari eq 'slave_ne_eq')))
   {
      summary_https ($upssettings{'MASTER'}, $upssettings{'HTTPSPORT'}, $upssettings{'UPSSTATS'},$upssettings{'MASTER'}) ;
   }
}

if (($upssettings{'UPSCLASS'} eq 'nisslave') && ($upssettings{'HTTP'} eq 'on'))
{
   if ($vari eq 'slave_ne_ne' || $vari eq 'slave_eq_ne')
   {
      netmon_slave_http ($upssettings{'MASTER'}, $upssettings{'HTTPPORT'},$upssettings{'MULTIMON'});
   }
   if (($upssettings{'IPCOP'} eq 'on' || ($upssettings{'IPCOP'} eq 'off')) && (($vari eq 'slave_ne_ne') || ($vari eq 'slave_ne_eq')))
   {
      summary_http ($upssettings{'MASTER'}, $upssettings{'HTTPPORT'}, $upssettings{'UPSSTATS'});
   }
}

data;
processes;
}

else

{
message;
}

&Header::closebigbox();

&Header::closepage();

exit 0;

}

############################################################################################################################

sub isrunning
{
	my $cmd = $_[0];
	my $status = "<td align='center' bgcolor='${Header::colourred}'><font color='white'><b>$Lang::tr{'stopped'}</b></font></td>";
	my $pid = '';
	my $testcmd = '';
	my $exename;

	$pidalive = 0;

	$cmd =~ /(^[a-z]+)/;
	$exename = $1;

	if (open(FILE, "/var/run/${cmd}.pid"))
	{
 		$pid = <FILE>; chomp $pid;
		close FILE;
		if (open(FILE, "/proc/${pid}/status"))
		{
			while (<FILE>)
			{
				if (/^Name:\W+(.*)/) {
					$testcmd = $1; }
			}
			close FILE;
			if ($testcmd =~ /$exename/)
			{
				$status = "<td align='center' bgcolor='${Header::colourgreen}'><font color='white'><b>$Lang::tr{'running'}</b></font></td>";
				$pidalive = 1;
			}
		}
	}

	return $status;
}

############################################################################################################################

sub updatecheck {

my $version = shift;

if ( (! -e '/var/ipcop/red/active') || (-e $addonupdate) && (int(-M $addonupdate) < 5) )
{
	return;
}

my $update = LWP::UserAgent->new;
$update->timeout(120);
my $content = $update->get("http://www.h-loit.de/update/upsversion");

if ( $content->is_success )
{
	$content->content =~ /(\d+).(\d+).(\d+)/;
	my $ver1 = $1;
	my $ver2 = $2;
	my $ver3 = $3;

	$version =~ /(\d+).(\d+).(\d+)/;

	if ( ($ver1 > $1) || (($ver1 == $1) && ($ver2 > $2)) || (($ver1 == $1) && ($ver2 == $2) && ($ver3 > $3)) )
	{
		return "$content";
	}
	else
	{
		system('/bin/touch', "$addonupdate");
	}
}	
}
